Summary: High Availability monitor built upon LVS, VRRP and service pollers
Name: keepalived
Version: 2.3.1
Release: 1%{?dist}
License: GPLv2+
URL: http://www.keepalived.org/
Source0: http://www.keepalived.org/software/keepalived-%{version}.tar.gz
Source1: keepalived.service

BuildRequires: gcc make
BuildRequires: net-snmp net-snmp-devel libmnl-devel libnftnl-devel
BuildRequires: systemd-units systemd-devel file-devel
BuildRequires: libnl3-devel libnfnetlink-devel openssl-devel

Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd

%description
Keepalived is a routing software written in C. The main goal of this
project is to provide simple and robust facilities for loadbalancing
and high-availability to Linux system and Linux based infrastructures.
Loadbalancing framework relies on well-known and widely used Linux
Virtual Server (IPVS) kernel module providing Layer4 loadbalancing.
Keepalived implements a set of checkers to dynamically and adaptively
maintain and manage loadbalanced server pool according their health.
On the other hand high-availability is achieved by VRRP protocol. VRRP
is a fundamental brick for router failover. In addition, Keepalived
implements a set of hooks to the VRRP finite state machine providing
low-level and high-speed protocol interactions. In order to offer
fastest network failure detection, Keepalived implements BFD protocol.
VRRP state transition can take into account BFD hint to drive fast state
transition. Keepalived frameworks can be used independently or all together
to provide resilient infrastructures.


%prep
%autosetup

%build
%configure \
    --enable-snmp --enable-snmp-rfc \
    --enable-nftables --disable-iptables \
    --enable-sha1 \
    --with-init=systemd
%make_build STRIP=/bin/true

%install
%make_install
rm -rf %{buildroot}%{_initrddir}/
rm -rf %{buildroot}%{_sysconfdir}/keepalived/samples/
mv %{buildroot}%{_sysconfdir}/keepalived/keepalived.conf.sample \
   %{buildroot}%{_sysconfdir}/keepalived/keepalived.conf
install -pm0644 -D %{SOURCE1} %{buildroot}%{_unitdir}/keepalived.service
mkdir -p %{buildroot}%{_libexecdir}/keepalived

%post
%systemd_post keepalived.service

%preun
%systemd_preun keepalived.service

%postun
%systemd_postun_with_restart keepalived.service

%files
%license COPYING
%doc AUTHOR ChangeLog CONTRIBUTORS README TODO
%doc doc/keepalived.conf.SYNOPSIS doc/samples/keepalived.conf.*
%dir %{_sysconfdir}/keepalived/
%dir %{_libexecdir}/keepalived/
%attr(0755,root,root) %{_sbindir}/keepalived
%{_bindir}/genhash
%{_datadir}/snmp/mibs/KEEPALIVED-MIB.txt
%{_datadir}/snmp/mibs/VRRP-MIB.txt
%{_datadir}/snmp/mibs/VRRPv3-MIB.txt
%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/sysconfig/keepalived
%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/keepalived/keepalived.conf
%{_unitdir}/keepalived.service
%{_mandir}/man1/genhash.1*
%{_mandir}/man5/keepalived.conf.5*
%{_mandir}/man8/keepalived.8*

%changelog
* Wed Sep 18 2024 Upgrade Robot <upbot@opencloudos.tech> - 2.3.1-1
- Upgrade to version 2.3.1 to fix CVE-2024-41184.

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.2.8-4
- Rebuilt for loongarch release

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.2.8-3
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Aug 04 2023 Xiaojie Chen <jackxjchen@tencent.com> - 2.2.8-2
- Rebuilt for file 5.45

* Wed Jul 12 2023 cunshunxia <cunshunxia@tencent.com> - 2.2.8-1
- upgrade to 2.2.8

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.2.7-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.2.7-2
- Rebuilt for OpenCloudOS Stream 23

* Fri Nov 25 2022 cunshunxia <cunshunxia@tencent.com> - 2.2.7-1
- initial build
